package cubo3d;

public class Transformador {
        
    public void rotX( Forma3D forma, double angulo ) {
        forma.getVertices().forEach( (v) -> {
            this.rotX( v.getVetor(), angulo ); 
        } ); 
    }
    
    public void rotY( Forma3D forma, double angulo ) {
        forma.getVertices().forEach( (v) -> {
            this.rotY( v.getVetor(), angulo ); 
        } );
    }
    
    public void rotZ( Forma3D forma, double angulo ) {
        forma.getVertices().forEach( (v) -> {
            this.rotZ( v.getVetor(), angulo ); 
        } );
    }
    
    public void rot( Forma3D forma, double xang, double yang, double zang ) {
        forma.getVertices().forEach( (v) -> {
            this.rot( v.getVetor(), xang, yang, zang ); 
        } );
    }
    
    public void perspectiva( Forma3D forma, double d ) {
        forma.getVertices().forEach( (v) -> {
            this.perspectiva( v, d ); 
        } );
    }
    
    public void rotX( double[] v, double angulo ) {
        double z = v[2]*Math.cos( angulo ) - v[1]*Math.sin( angulo );
        double y = v[2]*Math.sin( angulo ) + v[1]*Math.cos( angulo );
        v[2] = z;
        v[1] = y;
    }
    
    public void rotY( double[] v, double angulo ) {        
        double x = v[0]*Math.cos( angulo ) - v[2]*Math.sin( angulo );
        double z = v[0]*Math.sin( angulo ) + v[2]*Math.cos( angulo );
        v[0] = x;
        v[2] = z;
    }
    
    public void rotZ( double[] v, double angulo ) {
        double x = v[0]*Math.cos( angulo ) - v[1]*Math.sin( angulo );
        double y = v[0]*Math.sin( angulo ) + v[1]*Math.cos( angulo );
        v[0] = x;
        v[1] = y;
    }
    
    public void rot( double[] v, double alfa, double beta, double gama ) {
        double x = v[0];
        double y = v[1];
        double z = v[2];
        
        // ORDEM Y, X, Z <-> (Y->beta), (X->alfa), (Z->gama)
        
        v[0] = (x*Math.cos(beta)-z*Math.sin(beta))*Math.cos( gama ) + ( y*Math.cos(alfa) + ( ( x*Math.sin(beta)+z*Math.cos(beta) ) * (Math.sin(alfa) ) ) ) * (-Math.sin(gama) );
        v[1] = (x*Math.cos(beta)-z*Math.sin(beta))*Math.sin( gama ) + ( y*Math.cos(alfa) + ( ( x*Math.sin(beta)+z*Math.cos(beta) ) * (Math.sin(alfa) ) ) ) * ( Math.cos(gama) );
        v[2] = y*(-Math.sin(alfa)) + (x*Math.sin(beta) + z * Math.cos( beta ) ) * (Math.cos( alfa )); 
    }
    
    public void perspectiva( Vertice3D v, double d ) {
        this.perspectiva( v.getVetorCopia(), d );
    }
    
    public void perspectiva( double[] v, double d ) {
        double z = v[2];
        double f = ( d + z ) / d;
        v[0] *= f;
        v[1] *= f;
        //v[2] *= f;
    }
    
}
